Output Types
Reference for all build output types exposed to adapters.
The outputs object contains arrays of build output types:
outputs.pages: React pages from thepages/directoryoutputs.pagesApi: API routes frompages/api/outputs.appPages: React pages from theapp/directoryoutputs.appRoutes: API and metadata routes fromapp/outputs.prerenders: ISR-enabled routes and static prerendersoutputs.staticFiles: Static assets and auto-statically optimized pagesoutputs.middleware: Middleware function (if present)
Note: When config.output is set to 'export', only outputs.staticFiles is populated. All other arrays (pages, appPages, pagesApi, appRoutes, prerenders) will be empty since the entire application is exported as static files.
For any route output with runtime: 'edge', edgeRuntime is included and contains the canonical entry metadata for invoking that output in your edge runtime. Note that the Edge Runtime is deprecated.
Pages (outputs.pages)
React pages from the pages/ directory:
API Routes (outputs.pagesApi)
API routes from pages/api/:
App Pages (outputs.appPages)
React pages from the app/ directory:
App Routes (outputs.appRoutes)
API and metadata routes from the app/ directory:
Prerenders (outputs.prerenders)
ISR-enabled routes and static prerenders:
Prerender classification
routeType, response, and compute are emitted together on the primary response in a prerender group. Related RSC, data, and segment outputs omit these fields. Pages Router templates with fallback: false also omit them because those templates are never served for unmatched URLs.
routeType identifies the kind of canonical response:
route: a non-UI route, such as a Route Handlerpage: a page whose URL has no missing prerenderable parametersshell: the most specific reusable page shell for its class of URLsfallback: a reusable page response that can be specialized by filling more prerenderable parameters
response describes how complete the response is before request-time work:
empty: no initial page response can be servedinitial: an initial response can be served, but it is not the completed page UI. In practice, this only applies to UI routes that are partially prerenderablecomplete: the response is complete; this can include a zero-byte response body, such as a204Route Handler response
compute describes the request-time compute needed to serve the completed response:
blocking: no initial response can be sent before request-time compute starts; once started, the response can stream while compute continuesresuming: an initial response is served while postponed work resumes on the serverstatic: no server compute is required per request
htmlSize is only included on the primary App Router HTML output. A value of 0 means that the HTML shell is empty. Pages Router prerenders, Route Handlers, and related RSC, data, and segment outputs omit it.
Static Files (outputs.staticFiles)
Static assets and auto-statically optimized pages:
See Supporting immutable static assets for more information about immutableHash.
Middleware (outputs.middleware)
middleware.ts (.js/.ts) or proxy.ts (.js/.ts) function (if present):